#include "snake.h"

void snake::assign(vector<vector<int> > ps, CImg<unsigned char> &img)
{
    size = ps.size();
    for(int i = 0; i<size; ++i)
    {
        Vector2f v(ps[i][0],ps[i][1]);
        points.push_back(v);
    }
    image = img;
	//call to preProcess!!
    preProcess();
}

void snake::display(CImg<unsigned char> &img, CImgDisplay &disp, const unsigned char *const colorP, const unsigned char *const color)
{
    for(int i = 0; i<size-1; ++i)
    {
        img.draw_circle(points[i][0], points[i][1], 2, colorP);
        img.draw_line(points[i][0],points[i][1],points[i+1][0],points[i+1][1],color);
		//img.draw_arrow(points[i][0],points[i][1],points[i][0]-3*normal[i][0],points[i][1]-3*normal[i][1],color);
    }
    img.draw_circle(points[size-1][0], points[size-1][1], 2, colorP);
    img.draw_line(points[size-1][0],points[size-1][1],points[0][0],points[0][1],color);
}

void snake::setParams(float _gamma, float _alpha, float _beta)
{
	//sets the parameters for the energy functional as described in the slides
    gamma=_gamma; alpha=_alpha; beta=_beta;
}

void snake::preProcess()
{
    //// Implement this function
	//calculates the E (external term of the energy functional) and it's gradient
}

void snake::update() 
{
	//// Implement this function
	//performs ONE iteration to update the snake position
}

bool snake::stop() {return end;}
